var bv = BrainVoyager;
var $find = bv.FindChild;
var $setint = bv.SetPluginIntParameter;
var $getint = bv.GetPluginIntParameter;
var $setstring = bv.SetPluginStringParameter;
var $getstring = bv.GetPluginStringParameter;

o = new Object;
o.dialogFileName = "ConnA.ui";
o.dialogAccessName = "PluginDialog";

function ExecuteCommand(cmd)
{
    $setstring("Command", cmd);
    var result = bv.ExecutePlugin();

    return result;
}

o.initDlg = function()
{
    var dlg = this.PluginDialog;
    dlg.windowTitle = "ConnA - Connectivity Analysis";

//    $find("pb_RefreshVRMs").visible = false;
    $find("cbox_WriteToLogPane").visible = false;
//    $find("pbOpenPRT").setEnabled(false);
//    $find("cbox_AutoloadPRT").setEnabled(false);
//    $find("gbox_ProtocolTriggers").setEnabled(false);
    $find("pbSelectAllConditions").visible = false;
    $find("pbClearConditions").visible = false;

    //
    // Connect to signals/slots
    //
    $find("pbOpenVTC").clicked.connect(this, this.onOpenVTC);
    $find("pbOpenVOI").clicked.connect(this, this.onOpenVOI);
    $find("pbOpenPRT").clicked.connect(this, this.onOpenPRT);

//    #ifdef FEATURE_SUPPORT_PROTO
    $find("gbox_ProtocolTriggers").clicked.connect(this, this.onEnableTriggers);
    $find("pb_TriggerToCondition").clicked.connect(this, this.onTriggerToCondition);
    $find("pb_ConditionToTrigger").clicked.connect(this, this.onConditionToTrigger);
//    #endif

    $find("listVOIs").itemSelectionChanged.connect(this, this.onSelectionChanged);
    $find("pbSelectAllVois").clicked.connect(this, this.onSelectAllVois);
    $find("pbClearVois").clicked.connect(this, this.onClearVois);

    $find("rbtn_Treatment_Absolute").pressed.connect(this, this.onTreatmentAbsolute);
    $find("rbtn_Treatment_Positive").pressed.connect(this, this.onTreatmentPositive);
    $find("rbtn_Treatment_Negative").pressed.connect(this, this.onTreatmentNegative);

    $find("pbSelectOutputDirectory").clicked.connect(this, this.onSelectOutputDir);
    $find("pbStart").clicked.connect(this, this.onStart);
    $find("pbCancel").clicked.connect(this, this.onCancel);

    //
    // Initialize the plugin
    //
    var result = ExecuteCommand("InitPlugin");

    //
    // Populate the VMRs list
    //
    var vmr_curr_selected = $getint("VMR_CURRENTLY_SELECTED");
    var vmrs_ids = String($getstring("VMR_IDS"));
    var vmrs_names = String($getstring("VMR_NAMES"));

    var arr_vmrs_ids = vmrs_ids.split(",");
    var arr_vmrs_names = vmrs_names.split(",");
    var selected_id_idx = -1;
    var internal_i = 0;
    for (var i=0; i<arr_vmrs_names.length; i++) {
        var it = arr_vmrs_names[i];

        if (it.length != 0) {
            var id = arr_vmrs_ids[i];
            $find("cbox_VMRs").addItem(it, id);

            if (vmr_curr_selected == id) {
                selected_id_idx = internal_i;
            }

            internal_i++;
        }
    }

    $find("cbox_VMRs").setCurrentIndex(selected_id_idx);
    $find("cbox_VMRs")["currentIndexChanged(int)"].connect(this, this.onVMRSelected);
}

o.onVMRSelected = function(vmr_index)
{
    $setint("SET_VMR_TO", vmr_index);

    var result = ExecuteCommand("SetVMR");
}

o.onOpenVTC = function()
{
    var result = ExecuteCommand("OpenVTC");

    if (result) {
        var vtc_file = $getstring("VTC_FILE");
        $find("pbOpenVTC").text = "Ok";
        $find("pbOpenVTC").toolTip = String(vtc_file);
    }
}

o.onOpenVOI = function()
{
    $find("listVOIs").clear();
    $find("pbClearVois").click();

    var result = ExecuteCommand("OpenVOI");

    if (result) {
        var voi_file = $getstring("VOI_FILE");
        $find("pbOpenVOI").text = "Ok";
        $find("pbOpenVOI").toolTip = String(voi_file);

        var vois_available = $getstring("VOIS_NAMES");
        vois_available = String(vois_available);

        arr_vois_available = vois_available.split(",");
        for (var i=0; i<arr_vois_available.length; i++) {
            var item = arr_vois_available[i];
            if (item.length != 0) {
                var item_obj = new QListWidgetItem();
                item_obj.setText(arr_vois_available[i]);
                item_obj.setData(100, i);

                $find("listVOIs").addItem(item_obj);
            }
        }

        $find("pbSelectAllVois").click();
    }
}

o.onOpenPRT = function()
{
    var auto_load = $find("cbox_AutoloadPRT").checked;
    $setint("AUTOLOAD_PRT", auto_load);

    var result = ExecuteCommand("OpenPRT");

    if (result) {
        //$find("listConditions").clear();

        var prt_file = $getstring("PRT_FILE");
        prt_file = String(prt_file);

        $find("pbOpenPRT").text = "Ok";
        $find("pbOpenPRT").toolTip = prt_file;

        var conditions = $getstring("PRT_CONDITIONS_AND_TRIGGERS");
        conditions = String(conditions);

        var arr_conditions = conditions.split(",");

        for (var i=0; i<arr_conditions.length; i++) {
            var condition = arr_conditions[i];

            if (condition.length != 0) {
                var item_obj = new QListWidgetItem();
                item_obj.setText(condition);
//                item_obj.setFlags(item_obj.flags | Qt.ItemIsUserCheckable);
                item_obj.setCheckState(Qt.Unchecked);

                $find("listConditions").addItem(item_obj);
            }
        }

    }

    $find("pbSelectAllConditions").click();
}

o.onEnableTriggers = function()
{
    var checked = $find("gbox_ProtocolTriggers").checked;
    $setint("ENABLE_PROTOCOL_TRIGGERS", checked);

    if (checked) {
        $find("listConditions").setEnabled(true);
        $find("listTriggers").setEnabled(true);
    } else {
        $find("listConditions").setEnabled(false);
        $find("listTriggers").setEnabled(false);
    }

    var result = ExecuteCommand("ToggleProtocol");
}

o.onSelectionChanged = function()
{
    var selected_items = $find("listVOIs").selectedItems();
    var selected_vois = [];

    for(var i=0; i<selected_items.length; i++) {
        var item = selected_items[i];

        var data = item.data(100);
        selected_vois.push(data);
    }

    selected_vois = selected_vois.join(",");

    $setstring("SELECTED_VOIS", selected_vois);
    ExecuteCommand("SetSelectedVOIs");
}

o.onSelectionTriggersChanged = function()
{
    var selected_items = $find("listConditions").selectedItems();
    var selected_triggers = [];

    for(var i=0; i<selected_items.length; i++) {
        var item = selected_items[i].text();
        selected_triggers.push(item);
    }

    selected_triggers = selected_triggers.join(",");

    $setstring("SELECTED_TRIGGERS", selected_triggers);
    ExecuteCommand("SetSelectedTriggers");
}

o.onTriggerToCondition = function()
{
    var lst_conditions = $find("listConditions");
    var lst_triggers = $find("listTriggers");

    var curr_index = lst_triggers.currentRow;
    var curr_item = lst_triggers.takeItem(curr_index);

    lst_conditions.addItem(curr_item);
}

o.onConditionToTrigger = function()
{
    var lst_conditions = $find("listConditions");
    var lst_triggers = $find("listTriggers");

    var curr_index = lst_conditions.currentRow;
    var curr_item = lst_conditions.takeItem(curr_index);

    lst_triggers.addItem(curr_item);
}

o.onSelectAllVois = function()
{
    $find("listVOIs").selectAll();
}

o.onClearVois = function()
{
    $find("listVOIs").clearSelection();
}

o.onTreatmentAbsolute = function()
{
    $setstring("TREATMENT_VALUES", "absolute");
    var result = ExecuteCommand("SetTreatmentValues");
}

o.onTreatmentPositive = function()
{
    $setstring("TREATMENT_VALUES", "positive");
    var result = ExecuteCommand("SetTreatmentValues");
}

o.onTreatmentNegative = function()
{
    $setstring("TREATMENT_VALUES", "negative");
    var result = ExecuteCommand("SetTreatmentValues");
}

o.onSelectOutputDir = function()
{
    var result = ExecuteCommand("SelectOutputDirectory");

    if (result) {
        var output_dir = $getstring("OUTPUT_DIR");
        $find("pbSelectOutputDirectory").text = "Ok; " + String(output_dir) + " created.";
        $find("pbSelectOutputDirectory").toolTip = String(output_dir);
    }
}

o.onStart = function()
{
    var uniqueid = $find("ptext_UniqueID").plainText;
    $setstring("UNIQUE_ID", uniqueid);

    var comments = $find("ptext_Comments").plainText;
    $setstring("USER_COMMENTS", comments);

//    #ifdef FEATURE_SUPPORT_PROTO
    //
    // Fetch Conditions
    //
    var lst_conditions = $find("listConditions");
    var len_conditions = lst_conditions.count;
    var selected_conditions = [];
    var all_conditions = [];
    for (i=0; i<len_conditions; i++) {
        var item = lst_conditions.item(i);
        if (item.checkState() == Qt.Checked) {
            selected_conditions.push(item.text());
        }

        all_conditions.push(item.text());
    }
    selected_conditions = selected_conditions.join(",");
    all_conditions = all_conditions.join(",");

    $setstring("ALL_CONDITIONS", all_conditions);
    ExecuteCommand("SetAllConditions");

    $setstring("SELECTED_CONDITIONS", selected_conditions);
    ExecuteCommand("SetSelectedConditions");

    //
    // Fetch Triggers
    //
    var lst_triggers = $find("listTriggers");
    var len_triggers = lst_triggers.count;
    var selected_triggers = [];
    var all_triggers = [];
    for (i=0; i<len_triggers; i++) {
        var item = lst_triggers.item(i);
        if (item.checkState() == Qt.Checked) {
            selected_triggers.push(item.text());
        }

        all_triggers.push(item.text());
    }
    selected_triggers = selected_triggers.join(",");
    all_triggers = all_triggers.join(",");

    $setstring("ALL_TRIGGERS", all_triggers);
    ExecuteCommand("SetAllTriggers");

    $setstring("SELECTED_TRIGGERS", selected_triggers);
    ExecuteCommand("SetSelectedTriggers");
//    #endif

    //
    // Go!
    //
    var result = ExecuteCommand("Start");
}

o.onCancel = function()
{
    var result = ExecuteCommand("Close");

    this.clearAll();

    this.PluginDialog.close();
}

o.clearAll = function()
{
    $find("ptext_Comments").clear();
}

returnScriptObj = function()
{
    return o;
}

returnScriptObj();
